// Tools Library
//
// Copyright (C) 2002  Navel Ltd.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Contact information:
//  Mailing address:
//    Marios Hadjieleftheriou
//    University of California, Riverside
//    Department of Computer Science
//    Surge Building, Room 310
//    Riverside, CA 92521
//
//  Email:
//    marioh@cs.ucr.edu

#include <Tools.h>

using namespace std;

int main(int argc, char** argv)
{
	Tools::ResourceUsage ru;

	ru.start();
	for (unsigned long cIndex = 0; cIndex < 1000; cIndex++)
	{
		cout << Tools::Random::nextZipfDouble(10.0, 50.0, 1.0) << endl;
	}
	ru.stop();

	cout << endl;

	ru.start();
	for (unsigned long cIndex = 0; cIndex < 1000; cIndex++)
	{
		cout << Tools::Random::nextUniformDouble() << endl;
	}
	ru.stop();

	cerr << "Total time: " << ru.getTotalTime() << endl;
	cerr << "User time: " << ru.getUserTime() << endl;
	cerr << "System time: " << ru.getSystemTime() << endl;
	cerr << "Page faults: " << ru.getPageFaults() << endl;
	cerr << "Read IO: " << ru.getReadIO() << endl;
	cerr << "Write IO: " << ru.getWriteIO() << endl;
	cerr << "Maximum size: " << ru.getMaxMemorySize() << endl;

	cout << endl;

	ru.reset();
	ru.start();
	for (unsigned long cIndex = 0; cIndex < 1000; cIndex++)
	{
		cout << Tools::Random::nextUniformDouble(10.0, 50.0) << endl;
	}
	ru.stop();

	cerr << "Total time: " << ru.getTotalTime() << endl;
	cerr << "User time: " << ru.getUserTime() << endl;
	cerr << "System time: " << ru.getSystemTime() << endl;
	cerr << "Page faults: " << ru.getPageFaults() << endl;
	cerr << "Read IO: " << ru.getReadIO() << endl;
	cerr << "Write IO: " << ru.getWriteIO() << endl;
	cerr << "Maximum size: " << ru.getMaxMemorySize() << endl;

	return 0;
}
