/** @if INTERNAL
 *
 *  @file       internal/lib.hpp
 *  @author     Taka
 *  @date       18apr97
 *  
 *  @copyright  (c) T. Muraoka 1997 (all rights reserved).
 *              Unauthorized use of this code is prohibited.
 *
 *  @brief      Internal library definitions.
 * 
 *  @licence    This software is provided 'as-is', without any express 
 *              or implied warranty.
 *
 *              In no event will the author be held liable for any damages 
 *              arising from the use of this software.
 *  
 *              Permission is granted to anyone to use this software 
 *              for any purpose, including commercial applications, 
 *              and to alter it and redistribute it freely, subject to 
 *              the following restrictions: 
 *
 *              - The origin of this software must not be misrepresented; 
 *                you must not claim that you wrote the original software. 
 *                If you use this software in a product, an acknowledgment 
 *                in the product documentation is requested but not required. 
 *
 *              - Altered source versions must be plainly marked as such, 
 *                and must not be misrepresented as being the original software. 
 *                Altered source is encouraged to be submitted back to 
 *                the original author so it can be shared with the community. 
 *                Please share your changes. 
 *
 *              - This notice may not be removed or altered from any 
 *                source distribution. 
 *
 *  @endif 
 */

#ifndef LIB_HPP
#define LIB_HPP

#include <cassert>

/* --- CLASS DEFINITION: CStricmpPred --------------------------------- */

class CStricmpPred
{

public:         // --- PUBLIC INTERFACE ---

    bool        operator()( const std::string& lhs , const std::string& rhs ) const 
    {
        // compare the strings
        return std::lexicographical_compare(lhs.begin(),lhs.end(),rhs.begin(),rhs.end(),ciCompare) ;    
    }

public:         // --- PUBLIC INTERFACE ---

    static bool ciCompare( char lhs , char rhs)
    {
        // compare the characters
        return (toupper(lhs) < toupper(rhs)) ; 
    }

} ;

/* --- DEBUGGING ------------------------------------------------------ */

// FUDGE! Replace my funky ASSERT() macros with the standard one for CodeProject.
#define ASSERT( expr , msg )    assert( (expr) )
#define ASSERT_ALWAYS( msg )    assert( false )
#define ASSERT_PTR( p )         assert( (p) != NULL )

/* -------------------------------------------------------------------- */

#endif // LIB_HPP
