#ifndef _CONFIG_FILE_PARSER_H
#define _CONFIG_FILE_PARSER_H

#include <fstream>
namespace cache
{
	//Forward References
	class CacheConfigStore;

	class ConfigFileParser
	{
	public:
		ConfigFileParser(std::string fileName);


		CacheConfigStore* parse();


		void readQueryParameters(std::ifstream& inputStream,
			CacheConfigStore &configStore);

		void readCacheParameters(std::ifstream& inputStream,
			CacheConfigStore &configStore);

		void readPrefetchParameters(std::ifstream& inputStream,
			CacheConfigStore &configStore);

		void readIndexParameters(std::ifstream& inputStream,
			CacheConfigStore &configStore);

		void readRTreeParameters(std::ifstream& inputStream,
			CacheConfigStore &configStore);

		~ConfigFileParser();

	private:
		std::string fileName;

	};
}
#endif //_CONFIG_FILE_PARSER_H