#ifndef _PREFETHER_HELPER_H
#define _PREFETHER_HELPER_H

#include <time.h>
#include <stdio.h>
#include <log/log.h>

namespace cache
{
	/*
	*	Just a helper Class used to 
	* create new PrefetcherHelper.
	*/
	class PrefetcherHelper
	{
	public:
		PrefetcherHelper(){			
		}

		/*************************************************************************
		undeterministic_max

		This function returns the index of the max value from an array.
		If there are multiple copies, it will return the index of any
		randomly selected value in the array.
		*************************************************************************/

		int undeterministic_max(double *v, int n)
		{						
			int max = get_max(v, n), j;			
			//jing				
			while (v[j=rand()%n] != v[max]);
			return j;
		}

	private:
		/*************************************************************************
		get_max

		This function returns the index of the max value from an array.
		If there are multiple copies, it will return the index of the first
		occurrence in the array.
		*************************************************************************/
		int get_max(double *v, int n)
		{
			int i, j;

			for (i=1, j=0; i<n; i++) if (v[i] > v[j]) j=i;
			return j;
		}

		debug::log::CMessageGroup prefetchHelperLogger;
	};
}
#endif //_PREFETHER_HELPER_H