#ifndef CFlatDimstack_H
#define CFlatDimstack_H

#include <xmdv/CFlatDisplay.h>
#include <xmdv/Vec2.h>

class CFlatDimstack : public CFlatDisplay 
{
private: 
    ARR<Vec2> poly;

public:
	CFlatDimstack(CFlatDisplayInformation* flat_info);
    ~CFlatDimstack();
    //draw single data
    void DrawSingleData(ARR<double> REF data, int datano = 0);
    void Draw();
	void ClutterBasedOrder();		// added by debbie 9/2003

    //event handlers
    void InputMouseMotion(int x, int y);
    void InputButtonPress(int button, int x, int y);
    void InputButtonRelease(int button, int x, int y);
    static void DrawSingleDimstackBin(grCanvas *canvas, const ARR<double> &data, const ARR<double> &size);

    static double XMAP(int i);
    static double YMAP(int X, double Y);
    static double YINVMAP(int X, double Y);
    static void DrawDimstackAxes(grCanvas *canvas);
    static void InputDimstackMouseMotion(grCanvas *canvas, int x, int y);
    void ds_outline(grCanvas *canvas, ARR<double> &size);
    void rec_fill(grCanvas *canvas, double basex, double basey, int nextx, int nexty,
          ARR<double> &size, int brush);

protected:
    //set parameters used for drawing, to be rewritten in subclasses;
    void SetParameters();

    //draw axes
    void DrawAxes();
    
    // Draw a single brush.
    void DrawSingleBrush(Brush *brush);

	// PAUL: draw_org
	// Used for drawing a the dimstack to a certain depth
	int sensible_limit;
	double sensible_X_blocksize;
	double sensible_Y_blocksize;
};


#endif



