#ifndef CMixedDisplays_H
#define CMixedDisplays_H

#include <xmdv/CDisplay.h>
#include <xmdv/CFlatDisplayInformation.h>
#include <xmdv/CHierDisplayInformation.h>
#include <xmdv/CFlatDisplay.h>
#include <xmdv/CHierDisplay.h>
#include <xmdv/brush.h>


class CMixedDisplay : public CDisplay
{
public:
    CFlatDisplayInformation*  flat_info;
    CHierDisplayInformation* hier_info;
    CFlatDisplay *curr_flat_display;
    CHierDisplay *curr_hier_display;
    char *image;
    int image_W;
    int image_H;

public:
	CMixedDisplay(CFlatDisplayInformation*  flat_info, CHierDisplayInformation* hier_info);
	CMixedDisplay() {}
	~CMixedDisplay();

    void SetCanvas(grCanvas *canvas);
	
    //draw the canvas
    void Draw();

//protected:
    void SetUnbrushedColorAndStyle();
    //draw all data
    void DrawAllData();
    //draw brushed data
    void DrawBrushedRegion();
    void TraceDrawFSBBrushedClusters( const Cluster &node );

    void InputMouseMotion(int x, int y);
    void InputButtonPress(int button, int x, int y);
    void InputButtonRelease(int button, int x, int y);
    void InputKeyPress(int key);
    void InputKeyRelease(int key);

    void SavePixels();
    void LoadPixels();


};



#endif

