//modified by Jing Yang after 7/6/2001
#ifndef CInterRingDimCluster_H
#define CInterRingDimCluster_H

#include <xmdv/InterRing/CInterRingCluster.h>
#include <xmdv/ARR.h>

enum REORDER_METHOD{ 
        PCA_REORDER,
        OPTIMAL_REORDER,
        RANDOM_REORDER
};


class CInterRingDimCluster : public CInterRingCluster
{
public:
    double weight; //its weight when calculate its parent dimension. it is meanless for root node; 
	int okc_id; //dim id in okc and cg file
//    double disagreement;  //disagreement of this node;

    //start_jing_PCA
    //this first PCA component of the dimension cluster.
    double *PCA1;
    double PCA1_min, PCA1_max;
    bool PCAed;
    double PCA1_contribution; //contribution of this cluster to its parent's PCA1
    //end_jing_PCA


public:
	CInterRingDimCluster();
	~CInterRingDimCluster();
    
    double Calculate(ARR<double> all_data);
    int Calculate(ARR<int> all_data);
    void CalculateWithDimClusterExtends(ARR<double> all_data, double &mean, double &max, double &min);
	
    void ResetNames();

    void ChangeSelectedStatus(bool mark);

    //start_jing_PCA
    //this first PCA component of the dimension cluster.
    double* GetPCA1();
    bool PCA();
    //end_jing_PCA

    //set reorder_para according to pca contributions
    bool SetReorderParaAccordingToPCA();

    bool SetReorderPara(REORDER_METHOD choice);
    bool SetReorderPara();


protected:
    /////////choice: 1,optimal reorder; 2,random reorder; 3,artificial ants reorder////////////////////////////////////
    bool SetReorderParaAccordingToChoice(int choice);

    void GetClusterData(int& n, int& m, double **&data);

};

/////////choice: 1,optimal reorder; 2,random reorder; 3,artificial ants reorder////////////////////////////////////
extern bool similarity_reorder_interring(int, int, double **, ARR<int> &, int, int, char *, int =-1);


#endif

