
#include <xmdv/ISubwindow.h>
#include <xmdv/ARR.h>

struct RGBt;
class Image;
class colormap;

class Segment : public ISubwindow
{
public:

	Segment(int nMaxPixel, int nColumnIndex,
		double mLeftLine, double dLeftAngle, bool bLeftLineDepX,
		double mRightLine, double dRightAngle, bool bRightLineDepX,
		double mDrawLine, double dDrawLineAngle, bool bDrawLineDepX,
		bool bMirrored, int nMirrorSegY, int nMirrorSegX, int nMirrorSegXY,
		ARR<Segment*> &segments);
	~Segment();

	void	resetFunctionValues();
	/*virtual*/ void Paint(Image *img,double samplingFactor=1.0,bool hilite=false);
	/*virtual*/ bool Contains(float x, float y);

	int		initial_pixels(Image *image, int &x, int &y);
	int		left_pixels(Image *image, int nCounter, int &x, int &y);

protected:
	int		point_betw_lines(int x, int y);
	void	compute_next_point(int &x, int &y);
	void	moveDrawLine();
	void	changeDirection();
	void	writeToImage(Image *image, int x, int y, int index);

protected:
	enum { 
		NOT_MIRRORED = -1,
		X_MIRRORED = 0,
		Y_MIRRORED = 1,
		XY_MIRRORED = 2,
		BETWEEN = 2,
		BEFORE = 3,
		BEHIND = 4,
		ELSEWHERE = 5,
		ONLINE_BEHIND = 6,
		ONLINE_BEFORE = 7, 
	};
	bool				m_bSegCalculated;
	int					m_nColumnIndex;
	int					m_nMaxPixel;
	RGBt				*m_colorChord;
	RGBt				*m_colorChordInv;
	double				m_mLeftLine;
	double				m_mRightLine;
	double				m_mDrawLine;
	double				m_dLeftAngle;
	double				m_dRightAngle;
	double				m_dDrawLineAngle;
	bool				m_bLeftLineDepX;
	bool				m_bRightLineDepX;
	bool				m_bDrawLineDepX;
	bool				m_bMirrored;
	int					m_nMirrored;
	int					m_nMirrorSegY;
	int					m_nMirrorSegX;
	int					m_nMirrorSegXY;
	ARR<Segment*>		&m_segments;
	int					m_nMoveIncrementor;
	int					m_nDrawLineT;
	int					m_nDrawLineDirection;
	bool				m_bFromLeftToRight;
	int					m_nLastDrawLineLength;
	colormap			*m_cmap;
	double				*m_norm;

};
