
#include <xmdv/CParcoordTool.h>
#include <xmdv/CHierParcoord.h>
#include <xmdv/XmdvTool.h>
#include <xmdv/ogl.h>
#include <xmdv/brush.h>

/*static*/ //ARR<double> CParcoordTool::tmp_min, CParcoordTool::tmp_max;

CParcoordTool::CParcoordTool(CFlatDisplayInformation* flat_info) : CFlatParcoord(flat_info)
{
}

/*static*/ void CParcoordTool::SaveDimMinMax()
{
    // Save the current magnification
    // Setup up full scale magnification
    //
	//added by Zaixian: two lines of SetLen()
	tmp_min.SetLen(g_globals.dataset->dims);
	tmp_max.SetLen(g_globals.dataset->dims);
    tmp_min = g_globals.dataset->dim_min;
    tmp_max = g_globals.dataset->dim_max;
    g_globals.dataset->dim_min = g_globals.dataset->org_dim_min;
    g_globals.dataset->dim_max = g_globals.dataset->org_dim_max;
}

/*static*/ void CParcoordTool::RestoreDimMinMax()
{
    // Restore magnification
    //
    g_globals.dataset->dim_min = tmp_min;
	g_globals.dataset->dim_max = tmp_max;
}

void CParcoordTool::Draw()
{
    if (!g_globals.dataset) return;

	if ( ! TestDimensionality() )
		return;

    canvas->MakeCurrent();
    canvas->SetBackground(interface_color[BG]);
    canvas->Clear();

    // Setup window parameters.
    // (duplicated from ogl.C)
    //
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    const double BORD = 0.1;
    glOrtho(-BORD,1+BORD,1+BORD,-BORD,-1,1);
    glMatrixMode(GL_MODELVIEW);

    SaveDimMinMax();

	// PAUL: precalc_math
	// this is ugly, because there is no SetParameters() called
	// when CParcoordTools is drawn
	CParcoord::SetCalcVals();

    // Paint the current brush
    DrawSingleBrush(g_globals.curr_brush);

    // Paint the axes and labels
    DrawParcoordAxes(canvas);

    RestoreDimMinMax();
}

void CParcoordTool::InputMouseMotion(int x, int y)
{
    SaveDimMinMax();
    CFlatParcoord::InputMouseMotion(x,y);
    RestoreDimMinMax();
}

void CParcoordTool::InputButtonPress(int button, int x, int y)
{
    SaveDimMinMax();
    CFlatParcoord::InputButtonPress(button,x,y);
    RestoreDimMinMax();
}

void CParcoordTool::InputButtonRelease(int button, int x, int y)
{
    SaveDimMinMax();
    CFlatParcoord::InputButtonRelease(button,x,y);
    RestoreDimMinMax();

    // Remark data after restoring min/max to sieve zoomed-out
    // points.
    appCanvasBrushHasChanged(Togl_Interp(canvas->GetWidget()));
}

