// HistMgmt.cpp: implementation of the HistMgmt class.
//
//////////////////////////////////////////////////////////////////////

#include <xmdv/SessionMgmt/HistMgmt.h>
#include <time.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HistMgmt::HistMgmt()
{
	initial_time = 0;
	already_started = 0;
	init_dword_time = 0;
}

HistMgmt::~HistMgmt()
{

}

double HistMgmt::getAbsoluteTime()
{
#ifndef _WIN32
	time_t end_op_time;
	time(&end_op_time);
    return (difftime(end_op_time, initial_time));
#else
	double secs;
	DWORD diff;
	DWORD end_op_time;
	end_op_time = GetTickCount();
	diff = (end_op_time - init_dword_time);  //number of milliseconds
	secs = (double)diff;	//we only want the total number of milliseconds
	return secs;
//	FILE *fp = fopen("c:\\time.out", "a");
//        fprintf(fp, "%u\n", end_op_time - start_op_time);
//    fclose(fp);
#endif
}


void HistMgmt::setInitialTime()
{
#ifndef _WIN32
	time(&initial_time);
#else
	init_dword_time = GetTickCount();
#endif
}
