#include <backend/Connection.h>
#include<backend/ConnectionFactory.h>
#include <backend/ResultSet.h>
#include <backend/Statement.h>
#include <backend/PreparedStatement.h>
#include <backend/DataTypeNotSupportedException.h>
#include<iostream>
#include <backend/odbc.h>

int main()
{	
	try{
		Connection *connection = 
			ConnectionFactory::getInstance()->makeConnection(std::string("xmdv"),
			std::string("xmdv"),
			std::string("try"));
		
		Statement* statement = connection->createStatement();		

		ResultSet* resultSet = statement->executeQuery("select * from iris_hist");

		std::cout<<"The output rows of the result set"<<std::endl;

		while(resultSet->next())
		{
			std::cout<<resultSet->getDouble(0)<<" "<<resultSet->getDouble(1)<<std::endl;

		} // while(resultSet->next())		
		delete(resultSet);
		delete(statement);
		delete(connection);
			
	}
	
	catch(otl_exception& p){ // intercept OTL exceptions
		std::cerr<<p.code<<std::endl; // print out error code
		std::cerr<<p.sqlstate<<std::endl; // print out error SQLSTATE
		std::cerr<<p.msg<<std::endl; // print out error message
		std::cerr<<p.stm_text<<std::endl; // print out SQL that caused the error
		std::cerr<<p.var_info<<std::endl; // print out the variable that caused the error
	}

	catch(DataTypeNotSupportedException de)
	{
		std::cout<<de.getMsg()<<std::endl;
	}

	return 0;
}

